on startMovie
  global oldSoundLevel, oldColorDepth
  set the randomSeed to the ticks
  set oldSoundLevel to the soundLevel
  set oldColorDepth to the colorDepth
  set the soundLevel to 7
  if the colorDepth <> 8 then
    set the colorDepth to 8
  end if
  cursor(200)
  set whichCursor to the number of cast "hand"
  cursor([whichCursor, whichCursor + 1])
  if the quickTimePresent = 0 then
    go("bail")
  end if
end

on stopMovie
  global oldSoundLevel, oldColorDepth
  cursor(0)
  set the soundLevel to oldSoundLevel
  set the colorDepth to oldColorDepth
  repeat with whichChannel = 1 to 48
    puppetSprite(whichChannel, 0)
  end repeat
  clearGlobals()
end

on goodBye
  go(25)
end

on checkRollOvers
  global CONTROLS
  if rollOver(22) then
    set the visible of sprite CONTROLS to 1
    set the visible of sprite (CONTROLS + 1) to 0
    set the castNum of sprite CONTROLS to the number of cast "lccw1"
  else
    if rollOver(23) then
      set the visible of sprite CONTROLS to 1
      set the visible of sprite (CONTROLS + 1) to 0
      set the castNum of sprite CONTROLS to the number of cast "lcw1"
    else
      if rollOver(24) then
        set the visible of sprite (CONTROLS + 1) to 1
        set the visible of sprite CONTROLS to 0
        set the castNum of sprite (CONTROLS + 1) to the number of cast "rccw1"
      else
        if rollOver(25) then
          set the visible of sprite (CONTROLS + 1) to 1
          set the visible of sprite CONTROLS to 0
          set the castNum of sprite (CONTROLS + 1) to the number of cast "rcw1"
        else
          set the visible of sprite CONTROLS to 0
          set the visible of sprite (CONTROLS + 1) to 0
        end if
      end if
    end if
  end if
end

on createBackgroundFlake
  global flakeList
  if count(flakeList) >= 10 then
    beep()
  else
    add(flakeList, birth(script "SnowflakePB", count(flakeList) + 1))
  end if
end

on createForegroundFlake
  global flakeList
  if count(flakeList) >= 10 then
    beep()
  else
    add(flakeList, birth(script "SnowflakePF", count(flakeList) + 1))
  end if
end

on animateSnowFlakes
  global flakeList, MUSIC_CHANNEL
  if (count(flakeList) > 0) and (the movieRate of sprite MUSIC_CHANNEL = 1) then
    repeat with t = 1 to count(flakeList)
      animateFlake(getAt(flakeList, t))
    end repeat
  end if
end

on shuffleSnowFlakes
  global flakeList, MUSIC_CHANNEL
  if count(flakeList) > 0 then
    repeat with t = 1 to count(flakeList)
      swapFlake(getAt(flakeList, t))
    end repeat
  end if
end

on charmFlakes
  global flakeList
  if count(flakeList) > 0 then
    repeat with t = 1 to count(flakeList)
      charmFlake(getAt(flakeList, t))
    end repeat
  end if
end

on increaseVolume
  global MUSIC_CHANNEL, MUSICBOX, CONTROLS, currentVolume, currentTune, cursor
  set theCast to the number of cast "lcw1"
  set whichSprite to CONTROLS
  set whichCursor to the number of cast "fist"
  cursor([whichCursor, whichCursor + 1])
  set the visible of sprite whichSprite to 1
  if the movieRate of sprite MUSIC_CHANNEL = 0 then
    set the movieRate of sprite MUSIC_CHANNEL to 1
    set the castNum of sprite MUSIC_CHANNEL to currentTune + MUSICBOX
    puppetSound("Click")
  end if
  if currentVolume = 250 then
    flashNose()
  else
    repeat while the stillDown
      set currentVolume to currentVolume + 25
      if currentVolume >= 250 then
        set currentVolume to 250
        set the volume of sprite MUSIC_CHANNEL to currentVolume
        exit repeat
      end if
      set the volume of sprite MUSIC_CHANNEL to currentVolume
      repeat with ix = 1 to 1000
        nothing()
      end repeat
      set the castNum of sprite whichSprite to the castNum of sprite whichSprite + 1
      if the castNum of sprite whichSprite > (theCast + 3) then
        set the castNum of sprite whichSprite to theCast
      end if
      updateStage()
    end repeat
  end if
  set the visible of sprite whichSprite to 0
  set whichCursor to the number of cast "hand"
  cursor([whichCursor, whichCursor + 1])
end

on decreaseVolume
  global MUSIC_CHANNEL, CONTROLS, currentVolume
  set theCast to the number of cast "lccw1"
  set whichSprite to CONTROLS
  set whichCursor to the number of cast "fist"
  cursor([whichCursor, whichCursor + 1])
  set the visible of sprite whichSprite to 1
  if the movieRate of sprite MUSIC_CHANNEL = 0 then
    flashNose()
  else
    repeat while the stillDown
      set currentVolume to currentVolume - 25
      if currentVolume <= 0 then
        set currentVolume to 0
        set the volume of sprite MUSIC_CHANNEL to currentVolume
        set the movieRate of sprite MUSIC_CHANNEL to 0
        puppetSound("Click")
        exit repeat
      end if
      set the volume of sprite MUSIC_CHANNEL to currentVolume
      repeat with ix = 1 to 1000
        nothing()
      end repeat
      set the castNum of sprite whichSprite to the castNum of sprite whichSprite + 1
      if the castNum of sprite whichSprite > (theCast + 3) then
        set the castNum of sprite whichSprite to theCast
      end if
      updateStage()
    end repeat
  end if
  set the visible of sprite whichSprite to 0
  set whichCursor to the number of cast "hand"
  cursor([whichCursor, whichCursor + 1])
end

on nextTune
  global MUSICBOX, MUSIC_CHANNEL, CONTROLS, INDICATOR, currentTune, currentVolume
  set whichCursor to the number of cast "fist"
  cursor([whichCursor, whichCursor + 1])
  if currentTune = 10 then
    flashNose()
  else
    set theCast to the number of cast "rcw1"
    set whichSprite to CONTROLS + 1
    set currentTune to currentTune + 1
    if the movieRate of sprite MUSIC_CHANNEL = 0 then
      flashVolumeKnob()
    else
      set the castNum of sprite MUSIC_CHANNEL to currentTune + MUSICBOX
      set the movieRate of sprite MUSIC_CHANNEL to 1
    end if
    set the castNum of sprite whichSprite to the castNum of sprite whichSprite + 1
    if the castNum of sprite whichSprite > (theCast + 3) then
      set the castNum of sprite whichSprite to theCast
    end if
    puppetSound("Click")
    set the castNum of sprite INDICATOR to the castNum of sprite INDICATOR + 1
    updateStage()
    repeat while the stillDown
      if currentTune < 10 then
        set currentTune to currentTune + 1
        if the movieRate of sprite MUSIC_CHANNEL = 0 then
          flashVolumeKnob()
        else
          set the castNum of sprite MUSIC_CHANNEL to currentTune + MUSICBOX
          set the movieRate of sprite MUSIC_CHANNEL to 1
        end if
        set the castNum of sprite whichSprite to the castNum of sprite whichSprite + 1
        if the castNum of sprite whichSprite > (theCast + 3) then
          set the castNum of sprite whichSprite to theCast
        end if
        puppetSound("Click")
        set the castNum of sprite INDICATOR to the castNum of sprite INDICATOR + 1
        updateStage()
      end if
    end repeat
  end if
  set the volume of sprite MUSIC_CHANNEL to currentVolume
  shuffleSnowFlakes()
  set whichCursor to the number of cast "hand"
  cursor([whichCursor, whichCursor + 1])
end

on previousTune
  global MUSICBOX, MUSIC_CHANNEL, CONTROLS, INDICATOR, currentTune, currentVolume
  set whichCursor to the number of cast "fist"
  cursor([whichCursor, whichCursor + 1])
  if currentTune = 1 then
    flashNose()
  else
    set theCast to the number of cast "rccw1"
    set whichSprite to CONTROLS + 1
    set currentTune to currentTune - 1
    if the movieRate of sprite MUSIC_CHANNEL = 0 then
      flashVolumeKnob()
    else
      set the castNum of sprite MUSIC_CHANNEL to currentTune + MUSICBOX
      set the movieRate of sprite MUSIC_CHANNEL to 1
    end if
    set the castNum of sprite whichSprite to the castNum of sprite whichSprite + 1
    if the castNum of sprite whichSprite > (theCast + 3) then
      set the castNum of sprite whichSprite to theCast
    end if
    puppetSound("Click")
    set the castNum of sprite INDICATOR to the castNum of sprite INDICATOR - 1
    updateStage()
    repeat while the stillDown
      if currentTune > 1 then
        set currentTune to currentTune - 1
        if the movieRate of sprite MUSIC_CHANNEL = 0 then
          flashVolumeKnob()
        else
          set the castNum of sprite MUSIC_CHANNEL to currentTune + MUSICBOX
          set the movieRate of sprite MUSIC_CHANNEL to 1
        end if
        set the castNum of sprite whichSprite to the castNum of sprite whichSprite + 1
        if the castNum of sprite whichSprite > (theCast + 3) then
          set the castNum of sprite whichSprite to theCast
        end if
        puppetSound("Click")
        set the castNum of sprite INDICATOR to the castNum of sprite INDICATOR - 1
        updateStage()
      end if
    end repeat
  end if
  set the volume of sprite MUSIC_CHANNEL to currentVolume
  shuffleSnowFlakes()
  set whichCursor to the number of cast "hand"
  cursor([whichCursor, whichCursor + 1])
end

on flashNose
  global CONTROLS
  set whichCursor to the number of cast "fist"
  cursor([whichCursor, whichCursor + 1])
  set theCast to the number of cast "nose1"
  set whichSprite to CONTROLS + 2
  set the castNum of sprite whichSprite to theCast
  set the visible of sprite whichSprite to 1
  repeat with ix = 1 to 3
    set the castNum of sprite whichSprite to theCast + ix
    updateStage()
  end repeat
  puppetSound("Buzz")
  repeat with ix = 3 down to 1
    set the castNum of sprite whichSprite to theCast + ix
    updateStage()
  end repeat
  set the visible of sprite whichSprite to 0
  set whichCursor to the number of cast "hand"
  cursor([whichCursor, whichCursor + 1])
end

on flashVolumeKnob
  global CONTROLS
  set whichSprite to CONTROLS
  set the castNum of sprite whichSprite to the number of cast "flash"
  repeat with ix = 1 to 4
    set the visible of sprite whichSprite to 1
    updateStage()
    set the visible of sprite whichSprite to 0
    updateStage()
  end repeat
end

on flashControls
  global CONTROLS
  set the visible of sprite CONTROLS to 1
  set the visible of sprite (CONTROLS + 1) to 1
  repeat with ix = 1 to 4
    set the castNum of sprite CONTROLS to the number of cast "lcw1"
    set the castNum of sprite (CONTROLS + 1) to the number of cast "rccw1"
    updateStage()
    set the castNum of sprite CONTROLS to the number of cast "lccw1"
    set the castNum of sprite (CONTROLS + 1) to the number of cast "rcw1"
    updateStage()
  end repeat
  set the visible of sprite CONTROLS to 0
  set the visible of sprite (CONTROLS + 1) to 0
end
